% ========= MACROS =========
\usepackage{keyval}
\usepackage{letltxmacro}

% >>>>>>>>> INFO IN HEADER =========
\newcommand{\iheader}[1]{
	\phantomsection
    \markright{#1}
    \addcontentsline{toc}{section}{#1}
}
\newcommand{\isection}[1]{
    \iheader{#1}
    \section*{#1}
}
% >>>>>>>>> CITES =========
\newcommand{\icite}[2][]{\citereset\citet[#1]{#2}}
\newcommand{\iacite}[2][]{\citereset\autocite[#1]{#2}}
\newcommand{\icitetitle}[2][]{\citereset\citetitle[#1]{#2}}

\makeatletter
% >>>>>>>>> IMAGE =========
\define@key{image}{pos}{\def\i@pos{#1}}
\define@key{image}{width}{\def\i@width{#1}}
\define@key{image}{caption}{\def\i@caption{#1}}
\define@key{image}{label}{\def\i@label{#1}}
\setkeys{image}{
	pos=H,
    width=\textwidth}
\newcommand{\image}[2][]{%
	\begingroup%
    \setkeys{image}{#1}%
    \begingroup\edef\x{\endgroup
        	\noexpand\begin{figure}[\i@pos]}\x
        \centering
        \includegraphics[width=\i@width]{#2}
        \caption{\i@caption}
        \label{\i@label}
        \end{figure}
	\endgroup%
}

\define@key{doubleimage}{pos}{\def\di@pos{#1}}
\define@key{doubleimage}{width}{\def\di@width{#1}}
\define@key{doubleimage}{caption}{\def\di@caption{#1}}
\define@key{doubleimage}{captiona}{\def\di@captiona{#1}}
\define@key{doubleimage}{captionb}{\def\di@captionb{#1}}
\define@key{doubleimage}{label}{\def\di@label{#1}}
\define@key{doubleimage}{labela}{\def\di@labela{#1}}
\define@key{doubleimage}{labelb}{\def\di@labelb{#1}}
\setkeys{doubleimage}{
	pos=H,
    width=\textwidth,
    labela="",
    labelb=""}
\newcommand{\doubleimage}[3][]{%
  \begingroup%
    \setkeys{doubleimage}{#1}%
    \begingroup\edef\x{\endgroup
        	\noexpand\begin{figure}[\di@pos]}\x
        \centering
        \begingroup\edef\x{\endgroup
        	\noexpand\begin{subfigure}{.48\di@width}}\x
          \centering
          \includegraphics[width=.98\linewidth]{#2}
          \caption{\di@captiona}
          \label{\di@labela}
        \end{subfigure}\hfill%
        \begingroup\edef\x{\endgroup
        	\noexpand\begin{subfigure}{.48\di@width}}\x
          \centering
          \includegraphics[width=.98\linewidth]{#3}
          \caption{\di@captionb}
          \label{\di@labelb}
        \end{subfigure}
        \caption{\di@caption}
        \label{\di@label}
      \end{figure}
    \endgroup%
}


% >>>>>>>>> TABENV =========
\define@key{tabenv}{pos}{\def\t@pos{#1}}
\define@key{tabenv}{caption}{\def\t@caption{#1}}
\define@key{tabenv}{label}{\def\t@label{#1}}
\setkeys{tabenv}{pos=H}
\newcommand{\tabenv}[3][]{%
	\begingroup%
    \setkeys{tabenv}{#1}%
    \begingroup\edef\x{\endgroup
        	\noexpand\begin{table}[\t@pos]}\x
        \centering
        \rowcolors{2}{lightgray!30}{white}
        \begin{tabular}{#2}
        	#3
        \end{tabular}
        \caption{\t@caption}
        \label{\t@label}
    \end{table}
	\endgroup%
}
\makeatother

% >>>>>>>>> ADD HYPERLINK =========
\DeclareCiteCommand{\citetitle}
  {\boolfalse{citetracker}%
   \boolfalse{pagetracker}%
   \usebibmacro{prenote}}
  {\ifciteindex
     {\indexfield{indextitle}}
     {}%
     \printtext{\printfield{labeltitle}}}
 %\printtext{\printfield{labeltitle}~(\printfield[bibhyperref]{labelyear})}}
  {\multicitedelim}
  {\usebibmacro{postnote}}
  
% >>>>>>>>> COMMENT =========
\newcommand{\icomment}[2]{\textcolor{cyan}{\itshape\bfseries\ul{#1}}\marginpar{\textcolor{red}{\bfseries #2}}}

% >>>>>>>>> TODO =========
\makeatletter
 \if@todonotes@disabled
 \renewcommand{\todo}[2]{#1}
 \else
 \LetLtxMacro{\oldtodo}{\todo}
 \renewcommand{\todo}[3][]{\texthl{#3}\oldtodo[color=blue!40,{#1}]{#2}}
 \fi
 \makeatother